//***********************************************************************************************************
//
// An Exception class
//
//
// author	Tony Madden	(tm@mqware.com)
//***********************************************************************************************************
#ifndef	X_EXCEPTION_DEFINED
#define	X_EXCEPTION_DEFINED

#define X_EXCEPTION_VERSION		"1.0.0"

#include	<vector>
#include	<string>
#include	<sstream>

#define		E_ERROR		8

using namespace std;

class	X_Exception{

private:
	long	lCode;
	long	lSubCode;
	
	X_Exception*	pInnerException;

	void	initVariables();

	string	sText;
	string	sThrownBy;

	void	setup(long ,long ,string ,string,const X_Exception*);
	void	setup(const X_Exception& x);

public:
	X_Exception(); 
	X_Exception(string); 
	X_Exception(long ,long ,string);
	X_Exception(long ,long ,string,string);
	X_Exception(long ,long ,string,string,const X_Exception&);
	X_Exception(const  X_Exception&); 
	
	virtual ~X_Exception(){};

	X_Exception& operator=( const X_Exception&); 

	long					getCode() ;
	X_Exception*const			getInnerException() ;
	long					getSubCode() ;
	string					getText() ;
	string					getThrownBy();
	static string			getVersion();

	void					setCode(long);
	void					setInnerException(const  X_Exception&);
	void					setSubCode(long);
	void					setThrownBy(string);
	void					setText(string);
	
	string					toString();

};



#endif
