//***********************************************************************************************************
//
// The X_String class has a load of string manipulation functions
//
//
// author	Tony Madden	(tm@mqware.com)
//***********************************************************************************************************

#ifndef X_STRING_DEFINED
#define X_STRING_DEFINED

#define X_STRING_VERSION		"1.0.0"

#include	<vector>
#include	<string>
#include	<map>
#include	<cstdio>
#include	<sstream>

#include	<x_exception.hpp>

using namespace std;

struct x_TrueIfLessThanString{
	bool operator()(const string& s1, const string& s2) const{
		return s1 < s2;
	}
};

typedef	map<string,string,x_TrueIfLessThanString> X_StrStrMap ;

typedef	map<string,vector<string>*,x_TrueIfLessThanString> X_StrVstrMap ;


class	X_String {
private:
	static string			pad(const string& ,char ,long	,bool );
public:
	

	
	static	bool			equalsIgnoreCase(const string&,const string&);
	static	bool			isAlpha(const string&);
	static	bool			isAlphaNumeric(const string&);
	static	bool			isNumeric(const string&);
	static	bool			isPrint(const string&);
	static	string			getVersion();
	static	string			padAfter(const string&,char,long);
	static	string			padBefore(const string&,char,long);
	static	string			removeEscapeCharacter(string , char);
	static	long			stringToLong(const string&);
	static	string			toLower(const string&);
	static	string			toUpper(const string&);
	static	string			trim(const string&);
	static	string			trim(const string&,long);
	

};




#endif

